//+------------------------------------------------------------------+
//|                                        macd zero cross lines.mq4 |
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 1

//
//
//
//
//

extern string TimeFrame     = "current time frame";
extern int    FastEmaPeriod = 20;
extern int    SlowEmaPeriod = 50;
extern int    AppliedPrice  = PRICE_CLOSE;
extern color  HighLineColor = Green;
extern color  LowLineColor  = Red;
extern string LinesPrefix   = "macd crosses";
extern int    LinesStyle    = STYLE_DOT;

//
//
//
//
//

double trend[];
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
    SetIndexBuffer(0,trend); SetIndexStyle(0,DRAW_NONE);
         timeFrame = stringToTimeFrame(TimeFrame);
   IndicatorShortName("MACD zero crosses "+timeFrameToString(timeFrame));         
}
int deinit()
{
   ObjectDelete(LinesPrefix+"-up");
   ObjectDelete(LinesPrefix+"-do");
   return(0); 
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-1,Bars-counted_bars);

   //
   //
   //
   //
   //
   
 	for(i = limit; i >= 0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
      double macd = iMA(NULL,timeFrame,FastEmaPeriod,0,MODE_EMA,AppliedPrice,y)-iMA(NULL,timeFrame,SlowEmaPeriod,0,MODE_EMA,AppliedPrice,y);
         trend[i] = trend[i+1];
            if (macd>0) trend[i] =  1;
            if (macd<0) trend[i] = -1;

      //
      //
      //
      //
      //

      if (trend[i] != trend[i+1])
      {
         string name   = LinesPrefix+"-do";
         double price  = Low[i];
         color  lcolor = LowLineColor;
         
            if (trend[i] == 1)
            {
               name   = LinesPrefix+"-up";
               price  = High[i];
               lcolor = HighLineColor;
            }
            
            //
            //
            //
            //
            //
            
            ObjectCreate(name,OBJ_HLINE,0,0,0);
               ObjectSet(name,OBJPROP_COLOR,lcolor);
               ObjectSet(name,OBJPROP_BACK,true);
               ObjectSet(name,OBJPROP_PRICE1,price);
               ObjectSet(name,OBJPROP_PRICE2,price);
               ObjectSet(name,OBJPROP_STYLE,LinesStyle);
      }
   }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(0);
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}